<template>
	<div class="layer-bg">
		<div class="mx-auto w-full md:w-690 md:pt-24 md:mb-60 lg:pt-16 lg:mb-32">
			<div
				v-show="page && SIGN_IN_ERROR"
				role="alert"
				class="py-2 mb-8 text-base leading-6 text-center text-black rounded-md bg-error-10 font-primary-font-light flex w-full items-center"
			>
				<p
					v-if="SIGN_IN_ERROR && !SIGN_IN_ERROR.includes('reset your password')"
					class="inline-block text-center ml-auto"
					v-html="page.invalidlogin"
				></p>
				<p v-else class="inline-block ml-auto text-center" v-html="page.accountlocked"> </p>
				<p
					tabindex="0"
					class="icon-close ml-auto mk-error-close mr-4 text-xs cursor-pointer"
					@keypress.enter="$store.commit('USER_STORE/SET_SIGN_IN_ERROR')"
					@click="$store.commit('USER_STORE/SET_SIGN_IN_ERROR')"
				></p>
			</div>
			<div
				class="flex flex-col md:justify-center md:items-center md:rounded-tr-lg lg:rounded-t h-130 md:h-184 lg:min-h-216 bg-mint-20 px-4 py-6 md:px-6 md:pt-12 md:pb-14 lg:px-14 lg:pt-14"
			>
				<h1 class="font-secondary-font-regular text-2xl md:text-28 lg:text-base2 leading-7 md:leading-8">
					Account sign-in
				</h1>
				<p
					v-if="messageContent && page"
					class="pt-8 md:pt-6 lg:pt-10 font-primary-font-light text-base leading-6"
					v-html="page.forgetemail"
				>
				</p>
				<p v-else class="pt-8 md:pt-6 lg:pt-10 font-primary-font-light text-base leading-6"> Welcome back. </p>
			</div>

			<div class="bg-white lg:rounded-b py-8 px-4 md:px-10 md:py-12 lg:p-14">
				<ValidationObserver ref="login_validation_observer" @keypress.enter="submit()">
					<div>
						<MkInput
							v-model="value.email"
							class="mb-4"
							variant="outline"
							label="Email"
							rules="required|email"
							name="email"
						/>
					</div>
					<div>
						<MkInput
							v-model="value.password"
							class="mb-4"
							type="Password"
							variant="outline"
							label="Password"
							rules="required"
							name="password"
						/>
					</div>
					<a
						href="/D2C/login/passwordReset"
						class="mt-10 md:mt-6 lg:mt-10 block text-black font-primary-font-bold text-base leading-6 mk-link"
						>I forgot my password</a
					>
					<div>
						<MkPrimaryButton
							:loading="submitProcess"
							:disabled="enableSignin"
							class="mt-10 md:mt-6 lg:mt-10 font-primary-font-regular text-base md:text-xl leading-6"
							button-title="Sign in"
							@click="submit"
						/>
					</div>
				</ValidationObserver>
			</div>
			<div
				v-if="!isEurope"
				class="flex justify-center items-center text-center mt-2 bg-white md:rounded-lg lg:rounded py-6"
			>
				<p class="font-primary-font-light text-base leading-6 w-56 md:w-auto">
					Didn’t buy from Molekule.com?
					<span
						tabindex="0"
						role="link"
						class="font-primary-font-bold pl-1 cursor-pointer mk-link"
						@click="$router.push('/D2C/register/')"
						@keypress.enter="$router.push('/D2C/register/')"
						>Register your device</span
					>
				</p>
			</div>
		</div>
	</div>
</template>

<script>
import { mapState } from 'vuex';
import { ValidationObserver } from 'vee-validate';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
export default {
	components: {
		MkInput,
		MkPrimaryButton,
		ValidationObserver,
	},
	layout: 'aurora-layout',
	async asyncData({ store, req }) {
		return { page: await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'my_login_page', req }) };
	},
	data() {
		return {
			enableSignin: true,
			submitProcess: false,
			value: {},
			loginCount: 0,
			messageContent: this.$route.query.from === 'forget',
		};
	},
	head() {
		return {
			title: 'Signin',
		};
	},
	computed: {
		...mapState('USER_STORE', [
			'SIGN_IN_ERROR',
			'COG_FORM_LOADING',
			'CUSTOMER_CART_ID',
			'CUSTOMERID',
			'CUSTOMER_PROFILE',
		]),
		...mapState('CART_STORE', ['CART']),
		...mapState(['isEurope']),
	},
	watch: {
		value: {
			deep: true,
			handler() {
				this.enableButton();
			},
		},
	},
	methods: {
		enableButton() {
			const inputValue = this.value;
			if (inputValue.email && inputValue.password) {
				this.enableSignin = false;
			} else {
				this.enableSignin = true;
			}
		},
		async submit() {
			try {
				const isValidInputs = this.$refs.login_validation_observer.validate();
				if (!isValidInputs) {
					return;
				}
				this.submitProcess = true;
				const isSuccesful = await this.$store.dispatch('USER_STORE/SIGN_IN', this.value);
				if (isSuccesful === 'pass') {
					this.$store.commit('USER_STORE/RESET_COG_FORMS');
					if (this.CART && this.CART.anonymousId) {
						await this.$store.dispatch('CART_STORE/MERGE_CART');
						this.$store.dispatch('MK_CART_STORE/TOGGLE_SIDE_CART', 'MK_SIDE_CART');
					}
					if (this.CUSTOMERID) {
						if (this.$route.query && this.$route.query.back) {
							await this.$router.push(decodeURIComponent(this.$route.query.back));
						} else {
							this.$router.push('/D2C/account/dashboard/');
						}
					}
				} else if (['login fails', 'locked'].includes(isSuccesful)) {
					this.loginCount++;
					if (this.loginCount === 4) {
						await this.$store.dispatch('USER_STORE/CHECK_USER_EXISTS', this.value);
					}
					if (isSuccesful === 'locked') {
						this.$store.commit('USER_STORE/SET_SIGN_IN_ERROR', {
							message: 'There have been too many failed login attempts. To access your account, reset your password.',
						});
						this.loginCount = 0;
						this.value = {};
						this.$refs.login_validation_observer.reset();
					}
				}
				this.submitProcess = false;
			} catch (error) {
				this.submitProcess = false;
			}
		},
	},
};
</script>

<style lang="postcss">
.icon-close.mk-error-close::before {
	color: #000;
}
</style>
